/**
 * <p>Copyright: Copyright (c) 2005, Knowledge Science Group, University of Calgary.
 * Permission to use, copy, modify, distribute and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that copyright
 * notice and this permission notice appear in supporting documentation.  The
 * Knowledge Science Group makes no representations about the suitability of
 * this software for any purpose.  It is provided "as is" without express or
 * implied warranty.</p>
 */

package kartaCASA.MASExplorer;

import karta.command.Command;

import kartaCASA.interfaces.KartaCommandFilterInterface;

/**
 * This filter is used by the MASExplorer.
 * 
 * Created on June 9, 2005
 * @author <a href="mailto:sedachv@cpsc.ucalgary.ca">Vladimir Sedach</a>
 * @version 0.05
 */
public class MASModelFilter implements KartaCommandFilterInterface {
	
	private int typeTable[];
	
	public MASModelFilter() {
		typeTable = new int[40];
		typeTable[Command.ADD_NODE] = -1;
		typeTable[Command.REMOVE_NODE] = -1;
		typeTable[Command.REMOVE_ARC] = -1;
		typeTable[Command.ADD_ARC] = -1;
		typeTable[Command.SET_NAME] = -1;
		typeTable[Command.MOVE_NODE]= 0;
		typeTable[Command.RESIZE_NODE] = 0;
		typeTable[Command.CLEAR_MAP] = -1;
		typeTable[Command.CON_ARC_TO_OBJ] = -1;
		typeTable[Command.DIS_ARC_FROM_OBJ] = -1;
		typeTable[Command.MOVE_ARC] = 0;
		typeTable[Command.SET_SELECTED] = 0;
		typeTable[Command.NEW_CONCEPT_MAP] = -1;
		typeTable[Command.MAP_UPDATE] = 0;
		typeTable[Command.BACKGROUND_COLOR] = 0;
		typeTable[Command.BRING_FORWARD] = 0;
		typeTable[Command.SEND_BACKWARD] = 0;
		typeTable[Command.TO_BACK] = 0;
		typeTable[Command.TO_FRONT] = 0;
		typeTable[Command.ADD_TO_ARROW_TABLE] = 0;
		typeTable[Command.REMOVE_FROM_ARROW_TABLE] = 0;
		typeTable[Command.ADD_TO_SHAPE_TABLE] = 0;
		typeTable[Command.REMOVE_FROM_SHAPE_TABLE] = 0;
		typeTable[Command.ADD_TO_COLOR_TABLE] = 0;
		typeTable[Command.REMOVE_FROM_COLOR_TABLE] = 0;
		typeTable[Command.MODIFY_OVERRIDING_SHEET] = 0;
		typeTable[Command.MODIFY_SHEET] = 0;
		typeTable[Command.ADD_SHEET] = 0;
	}

	public int IsCommandValid(Command command) {
		return typeTable[command.getType()];
	}
	
	public boolean commandTypeAffectsStateP(int type) {
		if (typeTable[type] == 0)
			return true;
		return false;
	}
}
