/**
 * <p>Copyright: Copyright (c) 2005, Knowledge Science Group, University of Calgary.
 * Permission to use, copy, modify, distribute and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that copyright
 * notice and this permission notice appear in supporting documentation.  The
 * Knowledge Science Group makes no representations about the suitability of
 * this software for any purpose.  It is provided "as is" without express or
 * implied warranty.</p>
 */
package kartaCASA;

import karta.util.ObjectID;
import karta.util.IDMapper;
import karta.command.Command;

/**
 * Abstract class that will hold methods for translating commands from specific application views to models and vice-versa.
 * The ModelToViewCommandTranslator should be subclassed to match the specific type of model agent it is supposed to be used
 * with, and the actual pointer to it is held by a KartaViewAgent.
 * 
 * Created on June 9, 2005
 * @author <a href="mailto:sedachv@cpsc.ucalgary.ca">Vladimir Sedach</a>
 * @version 0.03
 */
public class ModelViewCommandTranslator {

	/** Translates some Object entity to it's corresponding ObjectID. */
	public ObjectID getID(Object obj) {
		return null;
	}
	
	/** Translates some ObjectID to the entity it references. */
    public Object getModelEntity(ObjectID id) {
    	return null;
    }
    
    /** Maps some entity to the given ObjectID. */
    public void MapEntityToID(Object entity, ObjectID ID) {
    	
    }
    
    /** Maps some ObjectID back to some entity. */
    public void MapIDToEntity(ObjectID ID, Object entity) {
    	
    }

    /** Takes a Command and replaces all relevant fields with URLDescriptors in them to the corresponding agent IDs. */
    public void translateCommand(Command com) {
      	IDMapper mapper = new IDMapper() {public Object mapID(Object ID) { return (getID(ID) == null) ? ID: getID(ID); }};
      	Command.mapCommandIDs(com, mapper);
    }
}
