/**
 * <p>Copyright: Copyright (c) 2005, Knowledge Science Group, University of Calgary.
 * Permission to use, copy, modify, distribute and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that copyright
 * notice and this permission notice appear in supporting documentation.  The
 * Knowledge Science Group makes no representations about the suitability of
 * this software for any purpose.  It is provided "as is" without express or
 * implied warranty.</p>
 */
package kartaCASA.OntologyEditor;

import java.awt.Container;

import javax.swing.JFrame;
import javax.swing.JInternalFrame;

import casa.LAC;
import casa.exceptions.IPSocketException;
import casa.ui.AgentUI;

import kartaCASA.KartaSupervisorAgent;
import kartaCASA.ui.OntologySupervisorWindow;
import kartaCASA.ui.SupervisorAgentWindow;

import karta.KartaInstance;

/**
 * A supervisor agent with a special UI for the ontology editor.
 * 
 * Created on August 23, 2005
 * @author <a href="mailto:sedachv@cpsc.ucalgary.ca">Vladimir Sedach</a>
 * @version 0.03
 */
public class OntologyEditorSupervisor extends KartaSupervisorAgent {

	boolean debugp = false;
	
	public OntologyEditorSupervisor(Qualifiers quals, KartaInstance kinstance) throws IPSocketException {
		super(quals, kinstance);
		if (debugp)
			System.out.println("Finished making ontology editor supervisor.");
	}
	
	protected AgentUI makeDefaultGUI(String[] args, String userName) {
		in("OntologyEditorSupervisor.makeDefaultGUI");
		try {
			Container frame = null;
			if (LAC.LACinfo.desktop != null)
				frame = new JInternalFrame ();
			else
				frame = new JFrame ();
			supervisorUI = new OntologySupervisorWindow (this, frame);
			if (LAC.LACinfo.desktop != null)
				LAC.LACinfo.desktop.addAgentWindow (supervisorUI);
			supervisorUI.setSize (500, 500);
			supervisorUI.setName(this.getName());
			supervisorUI.setOpaque (true);
			supervisorUI.pack ();
			supervisorUI.show ();
		} catch (Exception ex) {
			println ("warning",
					"KartaSupervisorAgent: Unexpected exception trying to start the window",
					ex);
		}
		out("OntologyEditorSupervisor.makdeDefaultGUI");
		return supervisorUI;
	}
}
