/**
 * <p>Copyright: Copyright (c) 2005, Knowledge Science Group, University of Calgary.
 * Permission to use, copy, modify, distribute and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that copyright
 * notice and this permission notice appear in supporting documentation.  The
 * Knowledge Science Group makes no representations about the suitability of
 * this software for any purpose.  It is provided "as is" without express or
 * implied warranty.</p>
 */

package kartaCASA;

import karta.command.Command;

import kartaCASA.interfaces.KartaCommandFilterInterface;

/**
 * PassthroughFilter says that any Command given to it is valid and does not affect model state.
 * 
 * Created on June 8, 2005
 * @author <a href="mailto:sedachv@cpsc.ucalgary.ca">Vladimir Sedach</a>
 * @version 0.03
*/
public class PassthroughFilter implements KartaCommandFilterInterface {

	public int IsCommandValid(Command command) {
		return 0;
	}
	
	public boolean commandTypeAffectsStateP(int c) {
		return false;
	}

}
