/**
 * <p>Copyright: Copyright (c) 2005, Knowledge Science Group, University of Calgary.
 * Permission to use, copy, modify, distribute and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that copyright
 * notice and this permission notice appear in supporting documentation.  The
 * Knowledge Science Group makes no representations about the suitability of
 * this software for any purpose.  It is provided "as is" without express or
 * implied warranty.</p>
 */

package kartaCASA.interfaces;

/** 
 * KartaInterface defines some constants to be used by the Model/View/Supervisor agents in communication
 *
 * Created on June 6, 2005
 * @author <a href="mailto:sedachv@cpsc.ucalgary.ca">Vladimir Sedach</a>
 * @version 0.05
 */
public interface KartaAgentInterface {

    /** Act for telling a View to consider a command for execution */
    public static final String ACT_CONSIDER_COMMAND = "consider.command";
    
    /** Act requesting a state dump from a supervisor agent */
    public static final String ACT_GET_STATE = "get.state";

    /** A super-act for setting various things. */
    public static final String ACT_SET = "set";
    
    /** Act that tells the model agent to put the given state into the corresponding PersistentViewProxy's latest_state */
    public static final String ACT_SET_STATE = "set.state";
    
    /** Act that tells a model agent to set a translation mapping from some object to an ObjectID. */
    public static final String ACT_SET_MAPPING = "set.mapping";
    
    /** Act for a supervisor agent to join a view */
    public static final String ACT_JOIN_VIEW = "join.view";
    
    /** Act for a supervisor agent to withdraw from a view */
    public static final String ACT_WITHDRAW_VIEW = "withdraw.view";
    
    /** Act for a view agent to join a model */
    public static final String ACT_JOIN_MODEL = "join.model";
    
    /** Act for a view agent to withdraw from a model */
    public static final String ACT_WITHDRAW_MODEL = "withdraw.model";

    /** The name of the persistence language used by karta */
    public static final String KARTA_LANGUAGE = "karta-language";
}
