/**
 * <p>Copyright: Copyright (c) 2005, Knowledge Science Group, University of Calgary.
 * Permission to use, copy, modify, distribute and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that copyright
 * notice and this permission notice appear in supporting documentation.  The
 * Knowledge Science Group makes no representations about the suitability of
 * this software for any purpose.  It is provided "as is" without express or
 * implied warranty.</p>
 */

package kartaCASA.interfaces;

import karta.command.Command;

/**
 * Defines the protocol to be used between a KartaViewAgent and the various filter objects implementing the various applications of Karta.
 * Note that unlike the usual filters, a Karta command filter may have state!
 * 
 * Created on June 8, 2005
 * @author <a href="mailto:sedachv@cpsc.ucalgary.ca">Vladimir Sedach</a>
 * @version 0.03
 */
public interface KartaCommandFilterInterface {
	
	/** Returns -1 if the given Command is invalid, 0 if it is valid and does not affect model state, and 1 if it is valid and affects model state */
	public int IsCommandValid(Command command);
	
	/** This method can be used to determine whether a given command type will affect the model state (and therefore whether it can be executed optimistically) at a given point in time */
	public boolean commandTypeAffectsStateP(int type);
	
}
