/**
 * <p>Copyright: Copyright (c) 2005, Knowledge Science Group, University of Calgary.
 * Permission to use, copy, modify, distribute and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that copyright
 * notice and this permission notice appear in supporting documentation.  The
 * Knowledge Science Group makes no representations about the suitability of
 * this software for any purpose.  It is provided "as is" without express or
 * implied warranty.</p>
 */

package kartaCASA.ui;

import casa.ui.AgentInternalFrame;

import java.awt.Container;

import kartaCASA.KartaModelAgent;

/**
 * The user interface for a Karta model.
 * 
 * Created on June 15, 2005
 * @author <a href="mailto:sedachv@cpsc.ucalgary.ca">Vladimir Sedach</a>
 * @version 0.01
 */
public class ModelAgentWindow extends AgentInternalFrame {

    KartaModelAgent model;

    // model window needs to have a list of subscribing views, a list of incoming commands (faded as they're executed),
    // a list of sleeping views, differentiation between external and view generated events.
    
    public ModelAgentWindow(KartaModelAgent m, Container frame) {
        super(m, "Karta Model Agent: ", frame);

        this.model = m;

        pack();
    }
}
