/**
 * <p>Copyright: Copyright (c) 2005, Knowledge Science Group, University of Calgary.
 * Permission to use, copy, modify, distribute and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that copyright
 * notice and this permission notice appear in supporting documentation.  The
 * Knowledge Science Group makes no representations about the suitability of
 * this software for any purpose.  It is provided "as is" without express or
 * implied warranty.</p>
 */
package kartaCASA.ui;

import java.awt.Container;

import javax.swing.JMenuBar;
import javax.swing.JTabbedPane;

import kartaCASA.KartaSupervisorAgent;

/**
 * The user interface for the graphical ontology editor agent.
 * 
 * Created on August 23, 2005
 * @author <a href="mailto:sedachv@cpsc.ucalgary.ca">Vladimir Sedach</a>
 * @version 0.04
 */
public class OntologySupervisorWindow extends SupervisorAgentWindow {
	
	boolean debugp = false;
	
	public OntologySupervisorWindow (KartaSupervisorAgent sup, Container aFrame) {
		super(sup, aFrame);
		if (debugp)
			System.out.println("Now making ontology window.");
		((JTabbedPane)tabs.get(0)).removeAll();
		pack();
		((JTabbedPane)tabs.get(0)).addTab("Graph", null, supervisor.getKartaInstance().getUIPanel(), "Concept Map");
		pack();
		if (debugp)
			System.out.println("Finished making ontology window.");
	}

	public void setJMenuBar (JMenuBar menuBar) {
	}
}
